import pandas as pd
from huggingface_hub import list_models


heywhale_submissions = pd.read_csv("submission.csv")
# print(heywhale_submissions[["团队名称", "模型"]])

# for index, item in heywhale_submissions[["团队名称", "模型"]].iterrows():
#     # print(row)
#     print(item["团队名称"], item["模型"])

categories = ["animal", "science", "food", "landscape", "wildcard"]
parsed = []

for cat in categories:
    all_submissions = list_models(filter=["dreambooth-hackathon", cat], full=True)
    for submission in all_submissions:
        team = None
        submitted_link = None
        for index, item in heywhale_submissions[["团队名称", "模型"]].iterrows():
            if submission.id and submission.id in item["模型"]:
                if submitted_link is not None:
                    print('Error', submission.id, 'is already handled. Dual submission?')
                team = item["团队名称"]
                submitted_link = item["模型"]
        # heywhale fallback
        if not submitted_link:
            if '-heywhale' in submission.id:
                submitted_link = submission.id
        parsed.append((cat, submission.id, submission.likes, team, submitted_link))

df_all = pd.DataFrame(data=parsed, columns=["category", "ID", "likes", "team", "submitted_link"])
df_all.to_csv("raw.csv")

df_from_submission = df_all[df_all['submitted_link'].str.len() > 0]
df_from_submission.sort_values(by=["category", "likes"], ascending=False, inplace=True)
df_from_submission.to_csv('output.csv')
print(df_from_submission[['category', 'ID', 'likes', 'team']])

